<template>
  <v-card>
    <v-dialog v-model="dialog" max-width="500px">
      <v-card>
        <v-card-title>
          <span class="headline">Edit Order #{{editedItem.order_id}}</span>
        </v-card-title>

        <v-card-text>
          <v-container grid-list-md>
            <v-layout wrap>
              <v-flex xs12>
                <strong>Date: </strong>{{editedItem.date}}
              </v-flex>
              <v-flex xs12>
                <strong>By: </strong>{{editedItem.last_name}}, {{editedItem.first_name}}
              </v-flex>
              <v-flex xs12>
                <strong>Phone: </strong>{{editedItem.phone}}
              </v-flex>
              <v-flex xs12>
                <v-select
                  :items="statusList"
                  item-value="text"
                  label="Status"
                  :prepend-icon="editedItem.icon"
                  v-model="editedItem.status"
                ></v-select>
              </v-flex>
              <v-flex xs12>
                <strong>Comments: </strong>{{editedItem.comments}}
              </v-flex>
            </v-layout>
          </v-container>
        </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" flat @click.native="close">Cancel</v-btn>
          <v-btn color="blue darken-1" flat @click.native="save">Save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-data-table
      :headers="headers"
      :items="filteredOrders"
      :pagination.sync="pagination"
    >
      <!-- Hide some columns on small screen devices -->
      <template slot="items" slot-scope="props">
        <td>{{ props.item.date }}</td>
        <td class="text-xs-left" v-if="$vuetify.breakpoint.mdAndUp">{{ props.item.last_name }}</td>
        <td class="text-xs-left" v-if="$vuetify.breakpoint.mdAndUp">{{ props.item.first_name }}</td>
        <td class="text-xs-left" v-if="$vuetify.breakpoint.mdAndUp">{{ props.item.phone }}</td>
        <td class="text-xs-left">
          <v-icon medium class="mr-2">{{ showIcon(props.item.status) }}</v-icon>
          {{ ($vuetify.breakpoint.mdAndUp) ? props.item.status : '' }}
        </td>
        <td class="justify-center layout px-0">
          <v-icon
            medium
            class="mr-2"
            @click="editItem(props.item)"
          >
            edit
          </v-icon>
        </td>
      </template>
      <template slot="no-data">
        <v-alert :value="true" color="accent" icon="info" transition="fade">
          No orders were found
        </v-alert>
      </template>
    </v-data-table>
  </v-card>
</template>

<script>
export default {
  name: 'SearchResults',
  data: () => ({
    dialog: false,
    editedIndex: -1,
    editedItem: {
      order_id: '',
      date: '',
      last_name: '',
      first_name: '',
      phone: '',
      status: '',
      comments: ''
    },
    defaultItem: {
      order_id: '',
      date: '',
      last_name: '',
      first_name: '',
      phone: '',
      status: '',
      comments: ''
    },
    commonHeadersStart: [
      {
        text: 'Date',
        align: 'left',
        sortable: false,
        value: 'date'
      }
    ],
    headersMdAndUp: [
      {
        text: 'Last name',
        align: 'left',
        sortable: false,
        value: 'last_name'
      },
      {
        text: 'Name',
        align: 'left',
        sortable: false,
        value: 'name'
      },
      {
        text: 'Phone',
        align: 'left',
        sortable: false,
        value: 'phone'
      }
    ],
    commonHeadersEnd: [
      {
        text: 'Status',
        align: 'left',
        sortable: true,
        value: 'status'
      },
      {
        text: 'Actions',
        value: 'order_id',
        sortable: false
      }
    ],
    pagination: {
      sortBy: 'order_id'
    },
    statusList: [
      'delivered',
      'error',
      'pending',
      'shipped'
    ]
  }),
  props: [
    'filteredOrders'
  ],
  computed: {
    headers: function () {
      // Hide some columns on small screen devices
      return (this.$vuetify.breakpoint.mdAndUp) ?
        [...this.commonHeadersStart, ...this.headersMdAndUp, ...this.commonHeadersEnd] :
        [...this.commonHeadersStart, ...this.commonHeadersEnd]
    }
  },
  watch: {
    // Update shown icon, according to new status
    'editedItem.status': function (val) {
      this.editedItem.icon = this.showIcon(val)
    }
  },
  methods: {
    showIcon (status) {
      return (status === 'delivered') ? 'where_to_vote' :
        (status === 'shipped') ? 'location_on' :
        (status === 'error') ? 'error' :
        (status === 'pending') ? 'watch_later' : 'departure_board'
    },
    editItem (item) {
      this.editedIndex = this.filteredOrders.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialog = true
    },
    close () {
      this.dialog = false
      setTimeout(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      }, 300)
    },
    save () {
      Object.assign(this.filteredOrders[this.editedIndex], this.editedItem)
      this.$emit('editOrder', this.editedItem)
      this.close()
    }
  }
}
</script>
